package com.systinet.demos.simple;

import org.idoox.webservice.CallContext;

public class StockService {

    /**
     * simple authenticated method
     */
    public double getQuote(String symbol) throws AuthException {
       	// gets the callcontext 
        CallContext callContext = CallContext.getInstance();
        
        // get the usernam and authentication status from the callcontext
        // all values are stored in callcontext by the server-side header
        // processor - see the ServiceAuthenticator.java
        String username = (String)callContext.get(ServerAuthenticator.USERNAME);
        String auth = (String)callContext.get(ServerAuthenticator.AUTHENTICATION);
        
        System.err.println("Calling with username "+username+".");
        // performs simple authorization
        if(ServerAuthenticator.AUTHENTICATION_OK.equals(auth) 
            && username != null && username.equals("test")
        ) {
            if(symbol!=null && symbol.equalsIgnoreCase("SUNW"))
                return 10;
            if(symbol!=null && symbol.equalsIgnoreCase("MSFT"))
                return 50;
            if(symbol!=null && symbol.equalsIgnoreCase("BEAS"))
                return 11;
        }
        else {
            throw new AuthException("Authentication failed.");
        }
        return 0;
    }
    

}